]> git.madduck.net Git - code/vcsh.git/blobdiff - vcsh

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Clean up Dieter's patches
[code/vcsh.git] / vcsh
diff --git a/vcsh b/vcsh
index eb852a01aa9103fc4b4b1e953d2c67e20174a290..16bfa53f738e3fd0a80b105c84bd2bc74d02e251 100755 (executable)
--- a/vcsh
+++ b/vcsh
 #!/bin/sh
 
 #!/bin/sh
 
-[ "$VCSH_DEBUG" -gt 0 ] && set -x
+[ -n "$VCSH_DEBUG" ]      && set -x
+[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
+[ -z "$VCSH_BASE" ]       && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
 
 SELF=$(basename $0)
 
 
 SELF=$(basename $0)
 
-[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
-for check_directory in $XDG_CONFIG_HOME $XDG_CONFIG_HOME/vcsh $XDG_CONFIG_HOME/vcsh/repo.d
-do
-       if [ ! -d "$check_directory" ]; then
-               if [ -e "$check_directory" ]; then
-                       echo "$SELF: error: $check_directory exists but is not a directory" >&2
-                       exit 2
-               else
-                       mkdir $check_directory || (echo "$SELF: error: could not create $check_directory" >&2; exit 2)
-               fi
-       fi
-done
+help() {
+       echo "usage: $SELF <args>
 
 
-VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
+   clone <remote> \\
+         [<repo>]       Clone from an existing repository
+   help                 Display this help text
+   delete               Delete an existing repository
+   enter                Enter repository; spawn new $SHELL
+   init <repo>          Initialize a new repository
+   list                 List all repositories
+   run <repo> \\
+       <command>        Use this repository
+
+   seed-gitignore \\
+   <repo>               Seed .gitignore.d/<repo> from git ls-files
+   setup                Set up repository with recommended settings
+
+   <repo> <git command> Special command that allows you to run git commands
+                        directly without having to type so much ;)" >&2
+}
 
 debug() {
 
 debug() {
-       [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $1"
+       [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
 }
 
 verbose() {
 }
 
 verbose() {
-       if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $1"; fi
+       if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
 }
 
 }
 
-help() {
-       echo "usage: $SELF <args>
-
-   help           Display this help
+fatal() {
+       echo "$SELF: fatal: $1" >&2
+       exit $2
+}
 
 
-   list           List all repos
+error() {
+       echo "$SELF: error: $1" >&2
+}
 
 
-   use <repo>     Use this repository
-   run <repo>
-       <command>  Use this repository
+info() {
+       echo "$SELF: info: $1"
+}
 
 
-   init           Initialize a new repository
-   clone <remote>
-         [<repo>] Clone from an existing repository
+setup() {
+       git config core.worktree     "$GIT_WORK_TREE"
+       git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
+       git config vcsh.vcsh         'true'
+       touch   "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+       git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+}
 
 
-   exit           Exit vcsh mode" >&2
+init() {
+       verbose "init() begin"
+       [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
+       export GIT_WORK_TREE="$HOME"
+       mkdir -p "$GIT_WORK_TREE"
+       cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
+       cd "$GIT_WORK_TREE"
+       git init
+       setup
+       verbose "init() end"
 }
 
 use() {
 }
 
 use() {
-       verbose "use() start"
-       REPO_NAME="$1"
-       GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
-
+       verbose "use() begin"
        if [ ! -d "$GIT_DIR" ]; then
        if [ ! -d "$GIT_DIR" ]; then
-               echo E: no repository found for "$REPO_NAME" >&2
-               return 2
+               error "no repository found for '$VCSH_REPO_NAME'"
+               return 12
        fi
        fi
-
        export GIT_DIR
        export GIT_WORK_TREE="$(git config --get core.worktree)"
        export GIT_DIR
        export GIT_WORK_TREE="$(git config --get core.worktree)"
-       export VCSH_DIRECTORY="$REPO_NAME"
-       verbose "use() stop"
-}
-
-init() {
-       verbose "init() start"
-       [ -e "$GIT_DIR" ] &&
-               echo "$SELF: fatal: $GIT_DIR exists" &&
-               return 21
-       export GIT_WORK_TREE="$HOME"
-       mkdir -p $GIT_WORK_TREE
-       cd $GIT_WORK_TREE ||
-               (echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
-                exit 20) || exit 20
-       cd $GIT_WORK_TREE
-       git init
-       git config core.worktree $GIT_WORK_TREE
-       verbose "init() stop"
+       export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+       verbose "use() end"
 }
 
 }
 
-leave() {
-       unset GIT_DIR
-       unset GIT_WORK_TREE
-       unset VCSH_DIRECTORY
-}
 
 
-if [ "$1" = 'help' ] || [ "$#" -eq 0 ]; then
-       help
-       [ "$1" = 'help' ]
-       exit $?
+if [ "$1" = 'clone' ]; then
+       export VCSH_COMMAND="$1"
+       GIT_REMOTE="$2"
+       export GIT_REMOTE
+       VCSH_REPO_NAME="$3"
+       [ -z "$VCSH_REPO_NAME" ] && VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
+       export VCSH_REPO_NAME
+       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+elif [ "$1" = 'delete' ] ||
+     [ "$1" = 'enter' ] ||
+     [ "$1" = 'init' ] ||
+     [ "$1" = 'run' ] ||
+     [ "$1" = 'seed-gitignore' ] ||
+     [ "$1" = 'setup' ]; then
+       [ -z $2 ] && fatal "$1: please specify repository to work on" 1
+       export VCSH_COMMAND="$1"
+       export VCSH_REPO_NAME="$2"
+       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+       shift 2
+       export VCSH_EXTERNAL_COMMAND="$*"
+       if [ "$VCSH_COMMAND" = 'run' ]; then
+               [ -z "$VCSH_EXTERNAL_COMMAND" ] && fatal "$1 $2: please specify a command" 1
+       fi
+elif [ "$1" = 'help' ] ||
+     [ "$1" = 'list' ]; then
+       export VCSH_COMMAND="$1"
+else
+       [ -z $1 ] && help && exit 0
+       export VCSH_COMMAND='run'
+       export VCSH_REPO_NAME="$1"
+       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+       [ -d $GIT_DIR ] || { help; exit 1; }
+       shift 1
+       export VCSH_EXTERNAL_COMMAND="git $*"
+fi
 
 
-elif [ "$1" = 'list' ]; then
-       verbose "list start"
-       for i in $VCSH_BASE/*.git; do
-               echo $(basename $i .git)
-       done
-       verbose "list stop"
-       exit 0
 
 
-elif [ "$1" = 'run' ]; then
-       verbose "run start"
-       use $2
-       shift 2
-       "$@"
-       leave
-       verbose "run start"
-       exit 0
-
-elif [ "$1" = 'use' ]; then
-       verbose "use start"
-       if [ -n "$ZSH_VERSION" ]; then
-               if [ -o NO_IGNORE_EOF ]; then
-                       export VCSH_NO_IGNORE_EOF=1
-                       setopt IGNORE_EOF
+for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
+do
+       if [ ! -d "$check_directory" ]; then
+               if [ -e "$check_directory" ]; then
+                       fatal "'$check_directory' exists but is not a directory" 13
+               else
+                       info "attempting to create '$check_directory'"
+                       mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
                fi
                fi
-               vcsh_exit() {
-                       vcsh exit;
-                       zle reset-prompt;
-               }
-               zle -N vcsh_exit
-               bindkey '^d' 'vcsh_exit'
        fi
        fi
-       use $2
-       [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-       verbose "use stop"
-       exit 0
+done
 
 
-elif [ "$1" = 'clone' ]; then
-       verbose "clone start"
-       GIT_REMOTE="$2"
-       REPO_NAME="$3"
-       [ -z "$REPO_NAME" ] && REPO_NAME=$(basename $GIT_REMOTE .git)
-       export REPO_NAME
-       export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
-       init
 
 
-       git remote add origin $GIT_REMOTE
+if [ "$VCSH_COMMAND" = 'clone' ]; then
+       verbose "clone begin"
+       init
+       git remote add origin "$GIT_REMOTE"
        git config branch.master.remote origin
        git config branch.master.merge  refs/heads/master
        git fetch
        for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
                [ -e "$object" ] &&
        git config branch.master.remote origin
        git config branch.master.merge  refs/heads/master
        git fetch
        for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
                [ -e "$object" ] &&
-                       echo "$SELF: error: $object exists." &&
+                       error "'$object' exists." &&
                        VCSH_CONFLICT=1;
        done
                        VCSH_CONFLICT=1;
        done
-       [ -n "$VCSH_CONFLICT" ] &&
-               echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
-               exit 3
+       [ "$VCSH_CONFLICT" = '1' ] &&
+               fatal "will stop after fetching and not try to merge!
+  Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
        git merge origin/master
        git merge origin/master
-       vcsh use $REPO_NAME
        verbose "clone end"
 
        verbose "clone end"
 
-elif [ "$1" = 'init' ]; then
-       verbose "init start"
-       export REPO_NAME="$2"
-       export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
+#elif [ "$VCSH_COMMAND" = 'help' ] || [ "$#" -eq 0 ]; then
+elif [ "$VCSH_COMMAND" = 'help' ]; then
+       help
+
+elif [ "$VCSH_COMMAND" = 'delete' ]; then
+       verbose "delete begin"
+       old_dir="$PWD"
+       cd "$HOME"
+       use || exit $?
+       info "This operation WILL DETROY DATA!"
+       files=$(git ls-files)
+       echo "These files will be deleted:
+
+$files
+
+AGAIN, THIS WILL DELETE YOUR DATA!
+To continue, type \"Yes, do as I say\""
+       read answer
+       [ "x$answer" = "xYes, do as I say" ] || exit 16
+       for file in $files; do
+               rm -f $file || info "could not delete '$file', continuing with deletion"
+       done
+       rm -rf "$GIT_DIR" || info "could not delete '$GIT_DIR'"
+       cd "$old_dir"
+       verbose "delete end"
+
+elif [ "$VCSH_COMMAND" = 'enter' ]; then
+       verbose "enter begin"
+       use || exit $?
+       $SHELL
+       verbose "enter end"
+
+elif [ "$VCSH_COMMAND" = 'init' ]; then
+       verbose "init begin"
        init
        init
-       vcsh use $REPO_NAME
-       verbose "init stop"
-
-elif [ "$1" = 'exit' ]; then
-       verbose "exit start"
-       if [ -n "$ZSH_VERSION" ] && [ -n "$VCSH_NO_IGNORE_EOF" ]; then
-               unset VCSH_NO_IGNORE_EOF
-               setopt NO_IGNORE_EOF
+       verbose "init end"
+
+elif [ "$VCSH_COMMAND" = 'list' ]; then
+       verbose "list begin"
+       for i in "$VCSH_BASE"/*.git; do
+               echo $(basename "$i" .git)
+       done
+       verbose "list end"
+
+elif [ "$VCSH_COMMAND" = 'run' ]; then
+       verbose "run begin"
+       use || exit $?
+       $VCSH_EXTERNAL_COMMAND
+       verbose "run end"
+
+elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
+       verbose "seed-gitignore begin"
+       use || exit $?
+       # Switching directory as this has to be executed from $HOME to be of any use.
+       # Going back into old directory at the end in case `vcsh use` is reactivated.
+       old_dir="$PWD"
+       cd "$HOME"
+       gitignores=$(for file in $(git ls-files); do
+               while true; do
+                       echo $file; new="${file%/*}"
+                       [ "$file" = "$new" ] && break
+                       file="$new"
+               done;
+       done | sort -u)
+       tempfile=$(mktemp) || fatal "could not create tempfile" 51
+       echo '*' > "$tempfile"
+       for gitignore in $gitignores; do
+               echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
+               [ -d "$gitignore" ] && echo "$gitignore/*" | sed 's/^/!/'>> "$tempfile"
+       done
+       diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
+               rm -f "$tempfile" &&
+               exit
+       if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
+               info "'$HOME/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$HOME/.gitignore.d/$VCSH_REPO_NAME.bak'"
+               mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
+                       fatal "could not move '$HOME/.gitignore.d/$VCSH_REPO_NAME' to '$HOME/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
        fi
        fi
-       leave
-       [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-       verbose "exit stop"
-       exit 0
+       mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
+               fatal "could not move '$tempfile' to '$HOME/.gitignore.d/$VCSH_REPO_NAME'" 53
+       cd "$old_dir"
+       verbose "seed-gitignore end"
+
+elif [ "$VCSH_COMMAND" = 'setup' ]; then
+       verbose "seed-gitignore begin"
+       use   || exit $?
+       setup || exit $?
+       verbose "seed-gitignore end"
 
 else
        verbose "defaulting to calling help()"
        help
 
 else
        verbose "defaulting to calling help()"
        help
-       exit 3
+       fatal "You should never reach this code. File a bug, please." 99
 
 fi
 
 fi
-